;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = Slow game speed (Matrix-style)
;DWORD [object+12] = interval
;DWORD [object+16] = not used
;DWORD [object+20] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)
;DWORD [object+24] = initial run once value (for re-init)
;DWORD [object+28] = enter transition interval
;DWORD [object+32] = exit transition interval

AT100MAIN:
cmp [BIONICWOMAN_enabled],1
    jz RunAlreadyOnce100
cmp BYTE [ecx+20],3
    jz RunAlreadyOnce100
	or BYTE [ecx+20],2	;set run once bit (no matter if not used)
push edi
mov edi,ecx

	call MXTGetCurrentTransitionState
	cmp eax,1
	    jz AT100MAIN_InEnterTrans
	cmp eax,2
	    jz AT100MAIN_InEffect
	cmp eax,3
	    jz AT100MAIN_InExitTrans	   ;(preserves edx)

;(assume as if effect disabled if none of the above are set)
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov ecx,[edi+28]
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax
	mov [MXTStateEnabled],1

pop edi
RunAlreadyOnce100:
ret

AT100MAIN_InEnterTrans:
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]
	mov eax,[edi+32]
	mov [MXTExitTransitionInterval],eax

pop edi
ret

AT100MAIN_InEffect:
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],0     ;if in effect, do not do enter transition
	mov [MXTExitTransitionInterval],eax

pop edi
ret

AT100MAIN_InExitTrans:		;edx = time (tick) to last ActionType's end
;Same as new MXT effect start, but changes last tick setting
;to compensate for unfinished previous exit trans effect
;However, this generally only works for ATs where the entry transition
;time is the same as the exit transition time.

    push edx
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
    pop edx
	sub eax,edx
	mov [MXTLastTick],eax
	mov ecx,[edi+28]
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax

pop edi
ret

;==========================================================
AT100_REINIT:
mov eax,[ecx+24]	;reset initial runonce value (upon level restart)
mov [ecx+20],eax
mov eax,[esp+4] 	;standard
ret 4