;Note: CGun object contains a current Ammo value and a MaxAmmo value.
;MaxAmmo=DWORD [obj+68h] ; Ammo=DWORD [obj+6Ch]
;Note2: object that contains two active CGun objects stores them at
;offsets 0E34h and 0E38h from the start of the object (for the currently
;held and currently holstered weapons, respectively)

;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = Ammo value (0 if unused)
;DWORD [object+12] = AltAmmoCount value (0 if unused)
;DWORD [object+16] = number of times reload is to be performed per object
;DWORD [object+20] = which weapons to apply to
;DWORD [object+24] = saved number of times reload value (for re-init)

AT103MAIN:
push edi
push ebx
push esi

	cmp DWORD [ecx+16],0
	jz NoMoreReload_103

mov edi,ecx

xor ebx,ebx

mov eax,[ActiveGunRef]
mov edx,[eax]

mov eax,[edx]
mov ecx,[eax+08h]

mov edx,[ecx+0E34h]	;edx = possible primary CGun object
mov al,1		;check for 'hand' gun
call Verify_Reload_103

mov edx,[ecx+0E38h]	;edx = possible secondary CGun object
mov al,2		;check for holstered gun
call Verify_Reload_103

cmp DWORD [edi+16],-1
    jz NoLoopLimit_103	    ;no reload limit?

sub [edi+16],ebx	;only decrease reload count if a reload happened

NoLoopLimit_103:

NoMoreReload_103:
pop esi
pop ebx
pop edi
ret

;================================
;this verifies which gun the object specifies the reload
;to apply to and applies if needed using extra values if used

Verify_Reload_103:	;al = test value to specified weapon
	test edx,edx
	mov esi,[CGUNVTABLE]
		jz NoWeapon_103   ;make sure Anne is holding an object
	cmp [edx],esi
	    jnz NoWeapon_103	  ;make sure we have a CGun type object

	test BYTE [edi+16],al
		jz NoWeapon_103

	mov eax,[edi+8] 	;Ammo value
	test eax,eax
		jz NoAmmoValue_103
	mov [edx+6Ch],eax
	jmp NoWeapon_103
NoAmmoValue_103:

	mov eax,[edx+68h]	;object's MaxAmmo value
	sub eax,[edi+12]	;substract AltAmmoCount value
	mov [edx+6Ch],eax
	or ebx,1
NoWeapon_103:
ret

;==========================================================
AT103_REINIT:
mov eax,[ecx+24]
mov [ecx+16],eax
mov eax,[esp+4] 	;standard
ret 4