;============================================================
;MAIN NEWACTIONTYPE INITIALIZATION CODE
;============================================================
;->must return new object in esi if initsuccess

;====================================================================
INAT:			;eax = AT number
;====================================================================
push ebp
mov ebp,esp
sub esp,16		;possible local values, not necessarily used
push ecx
push edx
push ebx
push esi
push edi
xor edx,edx
mov [ebp-16],edx
mov [ebp-12],edx
mov [ebp-8],edx
mov [ebp-4],edx

	sub eax,100
	cmp eax,NUM_NEWACTIONTYPES
	jnb NoNewActionType

	jmp DWORD [ATINATTable+4*eax]

NoNewActionType:
	mov eax,[NO_AT_FOUND_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	jmp eax
;====================================================================
;DWORD list
;====================================================================
ATINATTable:
	dd	_AT100Init
	dd	_AT101Init
	dd	_AT102Init
	dd	_AT103Init
	dd	_AT104Init
	dd	_AT105Init
	dd	_AT106Init
	dd	_AT107Init
	dd	_AT108Init
	dd	_AT109Init

;====================================================================
_AT100Init:
;====================================================================
ALLOCAT 36
lea eax,[AT100]
mov [edi],eax
    xor ecx,ecx
mov [edi+4],ecx
mov [edi+8],DWORD 0.300000
mov [edi+12],DWORD 4500
mov [edi+16],ecx
mov [edi+20],ecx
mov [edi+28],ecx
mov [edi+32],ecx

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Interval,1
SETVALUE value_int,4

GETVALUE Frame,2		;run only once?
SETVALUE value_bool,6

GETVALUE X,3
SETVALUE value_int,8

GETVALUE Y,4
SETVALUE value_int,9

mov eax,[edi+20]
mov [edi+24],eax		;save runonce value (for re-init)

	jmp ExitINAT
;====================================================================
_AT101Init:
;====================================================================
ALLOCAT 20

lea eax,[AT101]
mov [edi],eax
mov DWORD [edi+4],0
	mov eax,[DefaultSlowSpeed]
mov DWORD [edi+8],eax
mov DWORD [edi+12],0

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Frame,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
_AT102Init:
;====================================================================

GETVALUE Sample,0		;get bitmap "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

mov ebx,edi
FINDSTRINGEND ebx
sub ebx,edi
    jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

cmp ebx,80
    ja NoNewActionType		;LIMIT STRING LENGTH TO 80 BYTES


lea edx,[ebx+28]		;28 for object, the rest for string

ALLOCAT edx
lea eax,[AT102]
mov [edi],eax
    xor eax,eax
    lea edx,[edi+28]
mov [edi+4],eax
mov [edi+8],edx
mov [edi+12],eax
mov [edi+16],eax
mov [edi+20],eax
mov [edi+24],eax

MOVESTRING [edi+28],[ebp-4],ebx

GETVALUE XPos,1
SETVALUE value_float,4

GETVALUE YPos,2
SETVALUE value_float,5

GETVALUE X,3
SETVALUE value_float,6

GETVALUE Y,4
SETVALUE value_float,7

	jmp ExitINAT
;====================================================================
_AT103Init:
;====================================================================
ALLOCAT 28
lea eax,[AT103]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax
    inc eax
mov [edi+16],DWORD -1
mov [edi+20],eax

GETVALUE Ammo,0
SETVALUE value_int,3

GETVALUE AltAmmoCount,1
SETVALUE value_int,4

GETVALUE LoopCount,2
SETVALUE value_int,5

GETVALUE Frame,3
SETVALUE value_int,6

mov eax,[edi+16]
mov [edi+24],eax

	jmp ExitINAT
;====================================================================
_AT104Init:
;====================================================================
ALLOCAT 20
lea eax,[AT104]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax

GETVALUE Frame,0
SETVALUE value_float,3

GETVALUE LoopCount,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
_AT105Init:
;====================================================================
GETVALUE Sample,0		;get video "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

mov ebx,edi
FINDSTRINGEND ebx
sub ebx,edi
    jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

lea edx,[ebx+20]		;20 for object, the rest for string

ALLOCAT edx
lea eax,[AT105]
mov [edi],eax
    lea edx,[edi+20]
mov [edi+4],DWORD 0
mov [edi+8],edx
mov [edi+12],DWORD 0

MOVESTRING [edi+20],[ebp-4],ebx

GETVALUE LoopCount,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
_AT106Init:
;====================================================================
GETVALUE Sample,0		;get hint "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

mov ebx,edi
FINDSTRINGEND ebx
sub ebx,edi
    jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

GETVALUE Frame,1		;get hint "Frame" string (to append)
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)

lea edx,[ebx+8] 		;8 for object, the rest for string

test eax,eax
     jz NoSecondAppendString_106     ;leave if no valid string
     cmp BYTE [edi],0
	 jz NoSecondAppendString_106
     mov [ebp-8],edi
     FINDSTRINGEND edi
     sub edi,[ebp-8]
     inc edi
     add edx,edi
     mov [ebp-12],edi		     ;2nd string length
NoSecondAppendString_106:

ALLOCAT edx
lea eax,[AT106]
mov [edi],eax
and [edi+4],DWORD 0

MOVESTRING [edi+8],[ebp-4],ebx

mov eax,[ebp-8]
test eax,eax
     jz NoSecondAppendString_106_2
     lea edx,[edi+8]
     add edx,ebx
     mov BYTE [edx-1],20h
     MOVESTRING [edx],[ebp-8],[ebp-12]
NoSecondAppendString_106_2:

	jmp ExitINAT

;====================================================================
_AT107Init:	;Sample = destination object to control
;====================================================================
GETVALUE Frame,0
SETVALUE2 value_int		  ;(in eax)
     mov ebx,eax
     test ebx,ebx
	 ; jz ExitINAT

     mov edx,sizeof.atxdrv_inst_data
     cmp ebx,1
	 jnz ATXDRVNotType1_INIT
	 mov edx,sizeof.atxdrv_type1
     ATXDRVNotType1_INIT:

ALLOCAT edx
lea eax,[AT107]
mov [edi+atxdrv_base.VTable],eax
and [edi+atxdrv_base.Ref],DWORD 0
mov [edi+atxdrv_base.Type],ebx

GETVALUE Target,1
SETVALUE2 value_string			  ;(in eax)
     push eax
call GetInstanceFromString
mov [edi+atxdrv_base.Instance],eax
     pop eax

invoke GETTEMPINST_PROC,eax,0,1
mov [edi+atxdrv_base.TempInstance],eax	  ;for AT18 method only
add esp,12

;/* TEMP
    cmp DWORD [edi+atxdrv_base.Type],1
	jz DoType1TempSet

       mov ecx,edi
       mov [ecx+atxdrv_inst_data.GravityPush],10.000000
       mov [ecx+atxdrv_inst_data.KeyHandlerTick],40
       mov [ecx+atxdrv_inst_data.MvtHandlerTick],40
       mov [ecx+atxdrv_inst_data.RotPosOffset],2.000000
       mov [ecx+atxdrv_inst_data.FrontFastAccel],0.400000
       mov [ecx+atxdrv_inst_data.FrontSlowAccel],0.2000000
       mov [ecx+atxdrv_inst_data.BackSlowAccel],0.200000
       mov [ecx+atxdrv_inst_data.BackBrakeDecel],0.500000
       mov [ecx+atxdrv_inst_data.NaturalDecel],0.100000
       mov [ecx+atxdrv_inst_data.RotationAccelL],0.200000
       mov [ecx+atxdrv_inst_data.RotationAccelR],0.200000
       mov [ecx+atxdrv_inst_data.RotationDecel],0.250000
       mov [ecx+atxdrv_inst_data.MaxFastVelocity],3.000000
       mov [ecx+atxdrv_inst_data.MaxSlowVelocity],1.500000
       mov [ecx+atxdrv_inst_data.MaxBackVelocity],1.500000
       mov [ecx+atxdrv_inst_data.MaxTurnVelocityL],0.350000
       mov [ecx+atxdrv_inst_data.MaxTurnVelocityR],0.350000
       mov [ecx+atxdrv_inst_data.MinVelocityForTurn],0.20000

       fld [edi+atxdrv_inst_data.RotPosOffset]
       fchs
       fstp [edi+atxdrv_inst_data.RotPosOffset]

       fld [edi+atxdrv_inst_data.MaxBackVelocity]
       fchs
       fstp [edi+atxdrv_inst_data.MaxBackVelocity]

       fld [edi+atxdrv_inst_data.MaxTurnVelocityR]
       fchs
       fstp [edi+atxdrv_inst_data.MaxTurnVelocityR]

NoTempType1Set:
;*/

       jmp ExitINAT

DoType1TempSet:
       mov [edi+atxdrv_type1.Tick],50
       mov [edi+atxdrv_type1.FWDFast],30.00000
       mov [edi+atxdrv_type1.FWDSlow],15.0000000
       mov [edi+atxdrv_type1.BackSlow],-15.000000
       mov [edi+atxdrv_type1.BackBrake],-30.000000
       mov [edi+atxdrv_type1.LeftRight],0.200000
       mov [edi+atxdrv_type1.FastLimit],40.000000
       mov [edi+atxdrv_type1.SlowLimit],30.500000
       mov [edi+atxdrv_type1.BackLimit],-30.000000
       mov [edi+atxdrv_type1.LeftRightLimit],100.000000
       mov [edi+atxdrv_type1.MvtZAngleMul],0.000000
       mov [edi+atxdrv_type1.UseQuatMulInvert],FALSE
       jmp ExitINAT

;====================================================================
_AT108Init:
;====================================================================
ALLOCAT 12
lea eax,[AT108]
mov [edi],eax
mov DWORD [edi+4],0
mov DWORD [edi+8],0
	jmp ExitINAT

;====================================================================
_AT109Init:
;====================================================================
GETVALUE Sample,0		;get particle name
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

push edi
call [CPARTICLESENCNAMEPROC]	;get "encrypted" particle name (ID)
mov ebx,eax
add esp,4

ALLOCAT 16
lea eax,[AT109]
xor ecx,ecx
mov [edi],eax
mov [edi+4],ecx
mov [edi+8],ebx 		    ;particle ID
mov [edi+12],ecx		    ;color

GETVALUE R_tscriptvalue,1
SETVALUE2 value_int		    ;(in eax)
	shl eax,16		    ;XXRR0000h
	mov esi,00FF0000h
	and esi,eax

GETVALUE G_tscriptvalue,2
SETVALUE2 value_int		    ;(in eax)
	shl eax,8		    ;00RRGG00h
	and eax,0000FF00h
	or esi,eax

GETVALUE B_tscriptvalue,3
SETVALUE2 value_int		    ;(in eax)
	and eax,000000FFh
	or esi,eax		    ;00RRGGBBh
	mov [edi+12],esi	    ;final color value

	jmp ExitINAT
;====================================================================
ExitINAT:
;====================================================================
	mov eax,[AT_FOUND_JUMPDEST]
mov esi,edi			;save object (address)
pop edi
add esp,4
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax

;====================================================================
UnableToAllocateMem:
;====================================================================
	mov eax,[AT_MEM_ERROR_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax
