;====================================================================
;MAIN EXE-SPECIFIC DATA STRUCTURE, referenced via esi register
;====================================================================

macro ATEntry name {
  label name
	times 10	dd	?      ;10*4 bytes = size of an ActionType VTable
}

;MAIN STRUCTURE FOR ALL GAME/PROC DATA/ADDRESSES

virtual at EXE_Specific_BaseData_MAIN

EXEID			dd ?	;ID (not inverted in FASM)
GameSpeedVarADDR	dd ?	;address of game speed variable
GravityVarADDR		dd ?
DrawDistanceVarADDR	dd ?
GetEntryValueProc	dd ?	;gets T-Script entries (see "GetEntryValueProc.txt")

LocationADDR		dd ?	;points to pointer to a displaced pointer to Anne's position object (CCamera)
ActiveGunRef		dd ?	;this is the very base address of a set of
				;addresses and objects that, at some point,
				;include a member that points to the active
				;guns' object (currently held by the player)
BaseDDSurfaceADDR	dd ?	;points to an object ADDR from which
				;the base DirectX surfaces can be
				;retrieved
ActBiteMethodADDR	dd ?
WND_DDSetCoopLevelCode	dd ?
CONSOLECODE_BASE_MOV	dd ?	;this is the base code for cheat scan

TRESSTRDBG_JUMPADDR	dd ?
DATASEC_STARTADDR	dd ?	;start of ".data" section
DATASEC_ENDADDR 	dd ?	;end of same section
LOC_MAP_JUMP_ADDR	dd ?	;DWORD [this+2]+6 + this = addr for no loc cheat

EXEPROC_GETDDSURFDC	dd ?
EXEPROC_RELEASEDDSURFDC dd ?
LEVELNAME_OBJ		dd ?	;used to find SCN file name (this address + 20 bytes = saved file path/SCN level name)
CHECKLEVELNAMEADDR	dd ?	;code address to check for file name/LOADINITIALBITMAP
				;(code near after calls leading to "Finished Loading!" reference)
SAVE_GAME_CODE_ADDR	dd ?
DINOS_OBJECT		dd ?	;used for DINOS cheat (= "AI System" main object)
WOO_AMMO_BOOL_ADDR	dd ?	;used ONLY for demo EXE (same for others)
PLAYER_OBJ_INVUL_ADDR	dd ?	;pointer to pointer to CPlayerPriv object

AT_MAIN_JUMP_ADDR	dd ?
NO_AT_FOUND_JUMPDEST	dd ?
AT_FOUND_JUMPDEST	dd ?
AT_MEM_ERROR_JUMPDEST	dd ?

VIDEO_OBJ_ALLOC_PROC	dd ?
VIDEO_PLAY_PROC 	dd ?
EXE_SIZE		dd ?
V_CODE_SIZE		dd ?
RDATA_START_ADDR	dd ?	;start of ".rdata" section

ACTGETOUTVTABLE 	dd ?
ACTSTAYNEARVTABLE	dd ?
WRITEJUMPADDR_WAKEUP	dd ?
WRITEJUMPADDR_SLEEP	dd ?

STRING_AI		dd ?
STRING_STAYNEARTARGET	dd ?
STRING_STAYAWAYTARGET	dd ?

DELETESWPCODE_ADDR	dd ?
CANIMAL_INIT_END_ADDR	dd ?
CANIMAL_VTABLE		dd ?
LOADSTRINGHINT_ADDR	dd ?

CURRENT_HINT_ID_ADDR	dd ?
WM_CHAR_HANDLER_ADDR	dd ?
CHANGE_POS_METHOD_ADDR	dd ?	;for "player" class
CONVERT_TO_FACING_PROC	dd ?

WM_KEYDOWN_HANDLER_ADDR dd ?
CTRL_F11_KEY_CHECK_ADDR dd ?
KEY_LIST_ADDR		dd ?
VIDEO_RELEASE_PROC	dd ?

A3D_DLL_STRING		dd ?
AT10_VTABLE_POINTER	dd ?
HIGHRES_PATCH_ADDR_1	dd ?
HIGHRES_PATCH_ADDR_2	dd ?

MENU_SLIDER_VTABLE	dd ?
MAINSCREENDDFLOAD1_ADDR dd ?
MAINSCREENDDFLOAD2_ADDR dd ?

MENU_BUTTON_VTABLE	dd ?
EXIT_RESTART_VTABLE	dd ?	;near instruction 'cmp dword ptr [esi+3C], 00000014'
MENU_CHECKBOX_VTABLE	dd ?

ENDOBJECTLOAD_ADDR	dd ?
DDRAW_OBJ_BASE		dd ?

GETINST_ADDR1		dd ?	;these are used to fetch instances from their names only
GETINST_PROC1		dd ?	;during ActionType initialization
GETINST_PROC2		dd ?
GETINST_ADDR2		dd ?
GETINST_PROC3		dd ?

CONVERTTOFACING_VAR1	dd ?	;DC25XXXXXXXXh = fsub qword [XXXXXXXXh]
DINO_VOCAL_OFFSET_PROC	dd ?
MENU_HOTSPOT_VTABLE	dd ?
NEWGAME_VTABLE		dd ?
QUICKLOADOK_VTABLE	dd ?

AI_SYSTEM_OBJ_ADDR	dd ?	;same as DINOS_OBJECT
AT18_VTABLE_POINTER	dd ?
GETTEMPINST_PROC	dd ?	;used by ActionType 18 (param1 = inst. name (source string), param2 = 0, param3 = should be 1),
				;does not pop params, returns string ID of passed string from EXE algorithm. Strings are CASE-SENSITIVE,
				;constrary to the CParticles CPARTICLESENCNAMEPROC proc which converts them to lowercase first (but then calls the same proc).
AT16_VTABLE_POINTER	dd ?

GETFILEATTRIB_INTERCEPT dd ?	;used by level load background extensions (main call)
LOADBGFILE_RET_ADDR	dd ?	;used by level load background extensions (to ID function caller)
GETOBJPHYSICSINDEXPROC	dd ?
OBJPHYSICSBASEADDR	dd ?
GETOBJPHYSICSOBJADDR	dd ?
SETOBJPHYSICSOBJPARAM	dd ?

GETCURSORPOSIGCALLADDR	dd ?
CPARTICLESBUFADDRVAR	dd ?
AT05FOGVTABLE		dd ?
AT13SKYVTABLE		dd ?

GLOBALCLUTSTARTTEMPADDR dd ?
GLOBALCLUTSTOPTEMPADDR	dd ?
GLOBALCLUTINTERCEPTADDR dd ?
PRELEVELLOADADDR	dd ?
FASTLOADINTERCEPTADDR	dd ?

CURRENTFOGCOLORADDR	dd ?	;CANNOT BE WRITTEN TO: VALID ONLY FOR READ-ONLY ACCESS (OR WILL CAUSE COLOR PROBLEMS)
AT06RENDERERVTABLE	dd ?
CPARTICLESENCNAMEPROC	dd ?	;1 param, does not pop, return value always valid
CPARTICLESGETOBJPROC	dd ?	;2 params (ENCRYPTEDNAME, 0), does not pop, return value null if particle object not found (CPARTICLES ONLY!!!)
DEFAULTFOGCOLORINTR	dd ?

GETOBJFROMSTRINGIDPROC	dd ?	;1 param (string ID); ecx must be value pointed to by [LocationADDR]
				;Will work for all existing instances with string IDs returned by CPARTICLESENCNAMEPROC or GETTEMPINST_PROC
PHINFOQUADRUPEDVTABLE	dd ?
CGUNVTABLE		dd ?
AT19_VTABLE		dd ?
CANIMALCCREATRIGBUFADDR dd ?

include "MaxActiveDinos\mad_basedata.inc"

ATEntry AT100	;these help define the main VTables for new ActionTypes
ATEntry AT101
ATEntry AT102
ATEntry AT103
ATEntry AT104
ATEntry AT105
ATEntry AT106
ATEntry AT107
ATEntry AT108
ATEntry AT109
ATEntry AT110

end virtual
