;============================================================
;STRUCTURES
;============================================================

struct jump_info			;for compatibility issues, this is kept separate from canimal_info
    Push	       dd      ?
    JumpAngle	       dd      ?
    JumpTendancy       dd      ?
    RepeatPeriod       dd      ?
    LastTickCount      dd      ?
ends

struct initial_info		  ;(standard location-orientation Tres format)
    Xpos	       dd      ?
    Ypos	       dd      ?
    Zpos	       dd      ?
    Wquat	       dd      ?
    Xquat	       dd      ?
    Yquat	       dd      ?
    Zquat	       dd      ?
ends

struct canimal_info
    Instance	       dd      ?	;for backward compatibility, should always be the first member of this struc
    Count	       dd      ?	;from 0 to infinite
    InitialData        initial_info
ends

struct CParticlesDefault
     Blood	       dd ?
     Bleed	       dd ?
     Water	       dd ?
     Terrain	       dd ?
     TerrainSand       dd ?
     MetalHard1        dd ?
ends


;must begin all atxdrv structures
struct atxdrv_base
    VTable	       dd      ?
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
ends

struct vector
    VectorX		  dd	  ?
    VectorY		  dd	  ?
    VectorZ		  dd	  ?
ends

struct quaternion
    QuatW		  dd	  ?
    QuatX		  dd	  ?
    QuatY		  dd	  ?
    QuatZ		  dd	  ?
ends

struct atxdrv_inst_data 	;should be DWORD aligned, no negative values
    VTable	       dd      ?
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
    GravityPush        dd      ?
    KeyHandlerTick     dd      ?
    MvtHandlerTick     dd      ?
    RotPosOffset       dd      ?       ;rotation position offset (1D, offsets effect of rotation)
    FrontFastAccel     dd      ?       ;floats/s^2 (acceleration)
    FrontSlowAccel     dd      ?
    BackSlowAccel      dd      ?
    BackBrakeDecel     dd      ?       ;used when velocity > 0
    NaturalDecel       dd      ?       ;used when no mvt keys pressed
    RotationAccelL     dd      ?       ;should be positive - rotation acceleration (left and right) (radian angles/S^2)
    RotationAccelR     dd      ?       ;should be negative
    RotationDecel      dd      ?       ;used when no rotation keys pressed (should be high)
    MaxFastVelocity    dd      ?
    MaxSlowVelocity    dd      ?       ;approximate
    MaxBackVelocity    dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MaxTurnVelocityL   dd      ?
    MaxTurnVelocityR   dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MinVelocityForTurn dd      ?
ends

struct atxdrv_type1	    ;should be DWORD aligned, no negative values
    VTable	       dd      ?    ;standard
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
    Tick	       dd      ?    ;keyrate limiter
    FWDFast	       dd      ?    ;acceleration values
    FWDSlow	       dd      ?
    BackSlow	       dd      ?    ; -> BackSlow = negative value
    BackBrake	       dd      ?    ; -> BackBrake = negative value
    LeftRight	       dd      ?
    FastLimit	       dd      ?    ;velocity values (do not apply acceleration
    SlowLimit	       dd      ?    ;if velocity is higher than these values in object's current
    BackLimit	       dd      ?    ;direction)   -> BackLimit = negative value
    LeftRightLimit     dd      ?
    MvtZAngleMul       dd      ?
    UseQuatMulInvert   dd      ?
ends

struct atxdrv_initial_velocity
    XVelocity	       dd      ?
    YVelocity	       dd      ?
    ZVelocity	       dd      ?
    WQuat	       dd      ?
    XQuat	       dd      ?
    YQuat	       dd      ?
    ZQuat	       dd      ?
ends

struct CAPTUREPARMS		;size = 96
    dwRequestMicroSecPerFrame	       dd      ?
    fMakeUserHitOKToCapture	       dd      ?
    wPercentDropForError	       dd      ?
    fYield			       dd      ?
    dwIndexSize 		       dd      ?
    wChunkGranularity		       dd      ?
    fUsingDOSMemory		       dd      ?
    wNumVideoRequested		       dd      ?
    fCaptureAudio		       dd      ?
    wNumAudioRequested		       dd      ?
    vKeyAbort			       dd      ?
    fAbortLeftMouse		       dd      ?
    fAbortRightMouse		       dd      ?
    fLimitEnabled		       dd      ?
    wTimeLimit			       dd      ?
    fMCIControl 		       dd      ?
    fStepMCIDevice		       dd      ?
    dwMCIStartTime		       dd      ?
    dwMCIStopTime		       dd      ?
    fStepCaptureAt2x		       dd      ?
    wStepCaptureAverageFrames	       dd      ?
    dwAudioBufferSize		       dd      ?
    fDisableWriteCache		       dd      ?
    AVStreamMaster		       dd      ?
ends

struct AVISTREAMINFO
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwFlags			       dd      ?
    dwCaps			       dd      ?
    wPriority			       dw      ?
    wLanguage			       dw      ?
    dwScale			       dd      ?
    dwRate			       dd      ?
    dwStart			       dd      ?
    dwLength			       dd      ?
    dwInitialFrames		       dd      ?
    dwSuggestedBufferSize	       dd      ?
    dwQuality			       dd      ?
    dwSampleSize		       dd      ?
    rcFrame			       RECT
    dwEditCount 		       dd      ?
    dwFormatChangeCount 	       dd      ?
    szName			       db      64 dup ?
ends

struct AVICOMPRESSOPTIONS
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwKeyFrameEvery		       dd      ?
    dwQuality			       dd      ?
    dwBytesPerSecond		       dd      ?
    dwFlags			       dd      ?
    lpFormat			       dd      ?
    cbFormat			       dd      ?
    lpParms			       dd      ?
    cbParms			       dd      ?
    dwInterleaveEvery		       dd      ?
ends

struct DIBDUMPHEADER
    AtxDIBId			       db      'ATXR'	   ;if included in final file, save was successful
    SaveFlags			       dd      ?
    HeaderSize			       dd      sizeof.DIBDUMPHEADER
    BitmapData			       BITMAPINFOHEADER 	sizeof.BITMAPINFOHEADER
    Framerate			       dd      ?
    FrameRepeatTableFileOffset	       dd      ?
    FrameRepeatTableFileOffsetHigh     dd      ?
    DiffFrameCount		       dd      ?	  ;excludes frame repetitions (new frames only)
    TrueFrameCount		       dd      ?	  ;includes repetitions
    MaxFrameCount		       dd      ?
    FrameRepCount		       dd      ?
    rv_rt_error_count		       dd      ?
ends

