;============================================================
DoAT10JUMPMainEmulInit:
;============================================================
;Note: jump info for instances stored in the jump data buffer
;follow the same instance order as the CAnimalBuffer.
;Jump data buffer is kept separate in case user wants to
;disable it and save a few kilobytes or less of memory.

push ebp
push ebx

	LOCALRELEASE [CAnimal_JUMP_Info_BUF]
	mov [BUFSIZE_canimal_jump],0

cmp [UseDisableActJumpNew],0
    jnz NoJUMPCodeInit
cmp [CAnimalBuffer],0
    jz NoJUMPCodeInit

	call GetCAnimalInstanceCount
	mov ecx,sizeof.jump_info
	mul ecx
	push eax
invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	pop ecx
	     jz NoJUMPCodeInit
	mov [BUFSIZE_canimal_jump],ecx
	mov [CAnimal_JUMP_Info_BUF],eax

	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov DWORD [edi],'JMP\'		 ;'JMP\' folder for jump data
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'	;modify extension

invoke GetPrivateProfileString,STRING_GENERAL,STRING_PUSH,Push_INIdef,Push_default,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_JUMPANGLE,JumpAngle_INIdef,JumpAngle_default,50,MapsDirBuffer
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_JUMPTENDANCY,[JumpTendancy_INIdef],MapsDirBuffer
	mov [JumpTendancy_default],eax
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_REPEATPERIOD,[RepeatPeriod_INIdef],MapsDirBuffer
	mov [RepeatPeriod_default],eax

	mov ebp,[CAnimal_JUMP_Info_BUF]
	mov ebx,[CAnimalBuffer]

RetrieveJumpValuesLoop:
	mov eax,[ebx+canimal_info.Instance]
	mov edx,[eax+0DCh]	;CBrain
	lea esi,[edx+220h]	;esi=pointer to instance/section name

invoke GetPrivateProfileFloat,esi,STRING_PUSH,Push_default,MapsDirBuffer
	mov [ebp+jump_info.Push],eax
invoke GetPrivateProfileFloat,esi,STRING_JUMPANGLE,JumpAngle_default,MapsDirBuffer
	push eax
	fld DWORD [esp]
	fmul [pidiv180] 		;convert angle to radians
	fstp [ebp+jump_info.JumpAngle]
	add esp,4
invoke GetPrivateProfileInt,esi,STRING_JUMPTENDANCY,[JumpTendancy_default],MapsDirBuffer

;------------
;NO JUMPING FOR QUADRUPEDS SETTING (applied via eax)
;------------
	cmp [UseDisableQuadrupedJumps],FALSE
	    jz NoUseDisableQuadrupedJumps
	    mov edx,[ebx+canimal_info.Instance]
	    mov ecx,[edx+28h]		;CInfo class
	    mov edx,[ecx+0Ch]		;physics class
	    mov ecx,[edx]		;physics class VTable
	    cmp ecx,[PHINFOQUADRUPEDVTABLE]    ;is quadruped?
		jnz NoUseDisableQuadrupedJumps
		xor eax,eax		;if so, set jump tendancy to null
	NoUseDisableQuadrupedJumps:
;------------

	mov [ebp+jump_info.JumpTendancy],eax
invoke GetPrivateProfileInt,esi,STRING_REPEATPERIOD,[RepeatPeriod_default],MapsDirBuffer
	mov [ebp+jump_info.RepeatPeriod],eax
	mov [ebp+jump_info.LastTickCount],0

	add ebp,sizeof.jump_info
	add ebx,sizeof.canimal_info
	cmp ebx,[CAnimalBufferEnd]
	    jb RetrieveJumpValuesLoop

mov ecx,[MapsPathSize]
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoJUMPCodeInit:
pop ebx
pop ebp
ret

;============================================================
ACTJUMPNEW_MAIN:	;ecx=ActBite object (dino-specific)
;============================================================
;AT10 object (64 bytes, also add 16 unknown bytes for 'safety'):
;[AT10+00h]      = VTable
;[AT10+00h]      = n/a (set to 0)
;BYTE [AT10+14h] = "Frozen" bool
;[AT10+18h]      = "Target" object
;BYTE [AT10+1Ch] = "Impulse" bool
;[AT10+38h]      = "Push" float
;[AT10+3Ch]      = "Emitter" object
;Note: the Emitter object here uses a CAnimal-type VTable. Only
;its standard methods are used (for all objects), so it will always work
;even though the Emitter is not of CAnimal type class.

push ebp
mov ebp,esp
sub esp,16
push edi
push esi
push ebx
push ecx	    ;ecx = CActivityBite class

	call RANDOMIZE_RANDOM_PROC
	mov ecx,[esp]

	mov edx,[CAnimalBuffer]
	test edx,edx
	mov ebx,[CAnimalBufferEnd]
	     jz no_dinojump_code

	FindDinoForActBiteInstanceLoop2:
	mov esi,[edx+canimal_info.Instance]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop2
	add edx,sizeof.canimal_info
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop2
	    jmp no_dinojump_code
END_FindDinoForActBiteInstanceLoop2:

	mov ebx,[CAnimal_JUMP_Info_BUF]
	mov eax,sizeof.jump_info
	test ebx,ebx
	mov ecx,[edx+canimal_info.Count]
	     jz no_dinojump_code

	mul ecx
	add ebx,eax
	;ebx = dino's jump info, esi = dino object

;ensure interval has elapsed (RepeatPeriod)
	invoke GetTickCount
	sub eax,[ebx+jump_info.LastTickCount]
	cmp eax,[ebx+jump_info.RepeatPeriod]
	    jb no_dinojump_code
	add [ebx+jump_info.LastTickCount],eax	;store last tick count

;determine if dino is to jump or not (randomly based on JumpTendancy value)

	stdcall GetRandomNumber,100
	cmp eax,[ebx+jump_info.JumpTendancy]
	    ja no_dinojump_code

	mov edi,AT10_EMITTER_SIM_OBJECT
	mov [edi+4],DWORD 0

	lea ecx,[ebx+jump_info.JumpAngle]	;(stored in radians)
	lea edx,[ebp-16]			;local quat
	call ToLocalQuat_AxisX

	lea eax,[esi+3Ch]			;source quat (rotation - dino's current orientation)
	lea ecx,[ebp-16]			;local quat (to be rotated)
	lea edx,[edi+3Ch]			;result
	call QuaternionMul

	mov eax,[esi+30h]
	mov [edi+30h],eax			;Xposition (Emitter)
	mov eax,[esi+34h]
	mov [edi+34h],eax			;Yposition (Emitter)

	fld DWORD [esi+38h]
	fsub [float_100]
	fstp DWORD [edi+38h]			;Zposition (Emitter)

	mov ecx,AT10_SIM_OBJECT
	mov eax,[ebx+jump_info.Push]
	mov [ecx+04h],DWORD 0
	mov [ecx+18h],esi			;Target
	or BYTE [ecx+1Ch],1			;Impulse
	mov [ecx+38h],eax			;Push (force)
	mov [ecx+3Ch],edi			;Emitter object
	mov edx,0.000000
	mov [ecx+14h],BYTE 0			;Frozen bool
	mov [ecx+08h],edx			;X velocity
	mov [ecx+0Ch],edx			;Y velocity
	mov [ecx+10h],edx			;Z velocity
	mov [ecx+2Ch],edx			;X facing value (axis ???)
	mov [ecx+34h],edx			;Z facing value (???)
	mov eax,[ecx]
	mov [ecx+30h],DWORD 1.000000		;Y facing value (???)
	call DWORD [eax+8]			;AT10 MAIN PROC

no_dinojump_code:
pop ecx
pop ebx
pop esi
pop edi
mov esp,ebp
pop ebp
ret

