;note: parts of this code assume that Trespasser's surfaces
;use only 16-bit pixel formats (which should always be true)

;=====================================================
RecordVideoCaptureRT_NEW:
;=====================================================

	mov eax,[dibfileheader.TrueFrameCount]
	test eax,eax
	    jnz NotFirstFrameCapture_NEW
	    call InitAudioCapture_REC
		 test [NewSaveMethod],SAVE_METHOD_NONE
		      jnz NoVideoRecordNewRT_A
	    invoke GetTickCount
	    mov [VideoStartTime],eax
	    jmp FirstFrameCaptureOK_NEW

	NotFirstFrameCapture_NEW:

		 test [NewSaveMethod],SAVE_METHOD_NONE
		      jnz NoVideoRecordNewRT_A

	cmp eax,[dibfileheader.MaxFrameCount]
	    jnb NoDoVideoCaptureRT_NEW

	invoke GetTickCount

	fild [dibfileheader.TrueFrameCount]
	sub esp,4
	fmul [vrdef_frametime]
	fistp DWORD [esp]
	pop ecx
	add ecx,[VideoStartTime]

	sub eax,ecx		     ;eax = time elapsed since last saved frame's time space
	    jb NoDoVideoCaptureRT_NEW

	cmp [NoLowFPSComp],FALSE
	    jnz NoLowFPSCompensation_A
	cdq
	mov ecx,[vrdef_frametime_INT]
	div ecx 		     ;time elapsed / time per frame = # times to repeat
				     ;last frame (not current, count truncated)
	and eax,0FFh		     ;(255 max repetitions + first display)

;set to repeat previous frame if (time since last frame) > (time per frame),
;otherwise will set repeat count to 0 (copy once only)
	mov ecx,[framerepeatcount_BUF]
	mov edx,[dibfileheader.DiffFrameCount]
	mov [ecx+edx-1],al
	add [dibfileheader.TrueFrameCount],eax	      ;include repetitions in this count (add 0 if none, incremented later)
	add [dibfileheader.FrameRepCount],eax	      ;update total frame repetitions count
	mov eax,[dibfileheader.TrueFrameCount]
	sub eax,[dibfileheader.MaxFrameCount]
	    jz NoDoVideoCaptureRT_NEW	    ;reached exact max frame count? (will only apply if repetition)
	    jna NotOverMaxFrameCount_A_NEW  ;make sure not over max frame count
	sub [ecx+edx-1],al		;update frame repeat count to stay under limit
	sub [dibfileheader.TrueFrameCount],eax
	jmp NoDoVideoCaptureRT_NEW

	NotOverMaxFrameCount_A_NEW:
	NoLowFPSCompensation_A:
	FirstFrameCaptureOK_NEW:

	mov eax,[NewSaveMethod]
	cmp eax,SAVE_METHOD_NEW_DX
	     jz DO_NEW_SAVE_METHOD_DXBLT
	test eax,SAVE_METHOD_OLD_BOOL
	     jnz DO_OLD_SAVE_METHOD_RT

;-------------------------------
; /* start back buffer frame copy
;-------------------------------
;get back buffer surface
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	mov edi,[ecx+4Ch]		;edi = DDSurface object
	test edi,edi
	     jz NoValidSurfaceObject_NEW
	mov eax,[edi]
	push 0
	push DDLOCK_READONLY+DDLOCK_WAIT+DDLOCK_SURFACEMEMORYPTR
	push newsavemethodSD			  ;surface description
	mov [newsavemethodSD.ddpfPixelFormat.dwSize],sizeof.DDPIXELFORMAT
	push 0
	push edi
	call DWORD [eax+DirectDrawSurface.Lock]
	test eax,eax
	     jnz NoValidSurfaceObject_NEW

;copy frame to temp buffer (last scanline in surface is first in buffer)
	push edi
	push ebp
	mov ecx,[dibfileheader.BitmapData.biHeight]
	mov eax,[newsavemethodSD.lPitch]
	dec ecx
	mov esi,[newsavemethodSD.lpSurface]
	mul ecx
	mov edx,[dibfileheader.BitmapData.biHeight]	;(edx for outer loop)
	add esi,eax					;esi points to last scanline
	mov eax,[dibfileheader.BitmapData.biWidth]
	mov ebx,eax
	shl eax,1					;width in bytes (16-bit)
	mov edi,[newsavetempbuffer]			;edi points to dest. buffer
	add eax,[newsavemethodSD.lPitch]

	mov ebp,[NewSaveMethod]
	cmp ebp,LAST_STD_NEW_METHOD_NUMBER
	    ja DoScreenCopyLoop_MMX
	jmp DWORD [NewSaveMethod_PROCTABLE+4*ebp]

DoScreenCopyLoop_MMX:
;MMX transfer loop *** This loop uses MMX to transfer video data 64 bits at a time. On my
;900Mhz Athlon, in the Trespasser testscene level, this is about 6 to 8 fps faster than using
;a standard 32-bit "rep movsd" loop. This could be further optimized with XMM registers.

	shr ebx,2			;width*2 = bytes, bytes/8=qwords (for inner loop)
	HeightLoopScreenFlash_NEWSAVE_MMX:
		mov ecx,ebx
		WidthLoopScreenFlash_NEWSAVE_MMX:
		movq mm0,QWORD [esi]
		add esi,8
		movq QWORD [edi],mm0
		add edi,8
		loop WidthLoopScreenFlash_NEWSAVE_MMX
	sub esi,eax
	sub edx,1
	    jnz HeightLoopScreenFlash_NEWSAVE_MMX
	emms		;clear MMX state for FPU usage

END_HeightLoopScreenFlash_NEWSAVE:
	pop ebp
	pop edi

;unlock back buffer surface
	push 0
	mov eax,[edi]
	push edi
	call DWORD [eax+DirectDrawSurface.Unlock]
;-------------------------------
; */ end back buffer frame copy
;-------------------------------

;write frame to file
	       push 0
	       mov edx,esp
	invoke WriteFile,[dibtempfile_handle],[newsavetempbuffer],[vrdef_bufsize],edx,0
	       pop edx
	       test eax,eax
	       mov ecx,rv_error_25
		   jz DO_REC_RT_ERROR_A_NEW
	       cmp edx,[vrdef_bufsize]
		   jnz DO_REC_RT_ERROR_A_NEW

	inc [dibfileheader.DiffFrameCount]
	inc [dibfileheader.TrueFrameCount]

	RV_FrameCaptureError_A_NEW:
	NoDoVideoCaptureRT_NEW:
	NoValidSurfaceObject_NEW:

;get device context to display video time using standard functions
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	call DisplayVideoTime

	mov eax,[BaseDDSurfaceADDR]
	push edi			 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

NoVideoRecordNewRT_A:
ret

;=====================================================
DoScreenCopyLoop_STD:
;=====================================================
	shr ebx,1			;width*2 = bytes, bytes/4=dqwords (for inner loop)
	HeightLoopScreenFlash_NEWSAVE_STD:
		mov ecx,ebx
		rep movsd
	sub esi,eax
	sub edx,1
	    jnz HeightLoopScreenFlash_NEWSAVE_STD
jmp END_HeightLoopScreenFlash_NEWSAVE

;=====================================================
DoScreenCopyLoop_FPU:
;=====================================================
	shr ebx,3			;moves 8 bytes at a time, but twice (16 total)
	HeightLoopScreenFlash_NEWSAVE_FPU:
		mov ecx,ebx
		WidthLoopScreenFlash_NEWSAVE_FPU:
		fild QWORD [esi]
		fild QWORD [esi+8]
		add esi,16
		fistp QWORD [edi+8]
		fistp QWORD [edi]
		add edi,16
		loop WidthLoopScreenFlash_NEWSAVE_FPU
	sub esi,eax
	sub edx,1
	    jnz HeightLoopScreenFlash_NEWSAVE_FPU
jmp END_HeightLoopScreenFlash_NEWSAVE

;=====================================================
DoScreenCopyLoop_SSE:
;=====================================================
	shr ebx,3
	HeightLoopScreenFlash_NEWSAVE_XMM1:
		mov ecx,ebx
		WidthLoopScreenFlash_NEWSAVE_XMM1:
		movups xmm0,DQWORD [esi]	    ;memory may not be aligned to 16 bytes depending on pitch
		add esi,16
		movntps DQWORD [edi],xmm0	    ;VirtualAlloc buffer assumed to be aligned by 16
		add edi,16
		loop WidthLoopScreenFlash_NEWSAVE_XMM1
	sub esi,eax
	sub edx,1
	    jnz HeightLoopScreenFlash_NEWSAVE_XMM1
jmp END_HeightLoopScreenFlash_NEWSAVE

;=====================================================
DoScreenCopyLoop_SSE2:
;=====================================================
	shr ebx,3
	HeightLoopScreenFlash_NEWSAVE_XMM2:
		mov ecx,ebx
		WidthLoopScreenFlash_NEWSAVE_XMM2:
		movdqu xmm0,DQWORD [esi]	    ;memory may not be aligned to 16 bytes depending on pitch
		add esi,16
		movntdq DQWORD [edi],xmm0	    ;VirtualAlloc buffer assumed to be aligned by 16
		add edi,16
		loop WidthLoopScreenFlash_NEWSAVE_XMM2
	sub esi,eax
	sub edx,1
	    jnz HeightLoopScreenFlash_NEWSAVE_XMM2
jmp END_HeightLoopScreenFlash_NEWSAVE

;=====================================================
DO_REC_RT_ERROR_A_NEW:	    ;ecx=string
;=====================================================
	SHOWTEMPMESSAGE ecx
	mov eax,[dibfileheader.rv_rt_error_count]
	inc eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [TempMessageParam2],eax
	invoke GetLastError
	mov [TempMessageParam1],eax
jmp RV_FrameCaptureError_A_NEW

;=====================================================
DO_OLD_SAVE_METHOD_RT:
;=====================================================
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	invoke CreateCompatibleDC,edi
	       test eax,eax
	       mov ecx,rv_error_20
		   jz DO_REC_RT_ERROR_A

	       mov [rv_temp_dc],eax

	invoke CreateDIBSection,edi,dibfileheader.BitmapData,DIB_RGB_COLORS,DIBBitsPointer,0,0
	       test eax,eax
	       mov ecx,rv_error_21
		   jz DO_REC_RT_ERROR_A
	       mov [rv_temp_bmp_handle],eax

	invoke SelectObject,[rv_temp_dc],eax
	       mov ecx,rv_error_22
	       test eax,eax
		   jz DO_REC_RT_ERROR_A
	       cmp eax,GDI_ERROR
		   jz DO_REC_RT_ERROR_A

	invoke BitBlt,[rv_temp_dc],0,0,[dibfileheader.BitmapData.biWidth],\
			[dibfileheader.BitmapData.biHeight],edi,0,0,SRCCOPY
	       test eax,eax
	       mov ecx,rv_error_23
		   jz DO_REC_RT_ERROR_A

;write frame to file
	       push 0
	       mov edx,esp
	invoke WriteFile,[dibtempfile_handle],[DIBBitsPointer],[vrdef_bufsize],edx,0
	       pop edx
	       test eax,eax
	       mov ecx,rv_error_25
		   jz DO_REC_RT_ERROR_A
	       cmp edx,[vrdef_bufsize]
		   jnz DO_REC_RT_ERROR_A

	inc [dibfileheader.DiffFrameCount]
	inc [dibfileheader.TrueFrameCount]

	RV_FrameCaptureError_A:
	RCALL DeleteDC,[rv_temp_dc]
	RCALL DeleteObject,[rv_temp_bmp_handle] 	;also releases raw DIB data buffer

	NoDoVideoCaptureRT:

	call DisplayVideoTime

	mov eax,[BaseDDSurfaceADDR]
	push edi			 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

ret

;=====================================================
DO_REC_RT_ERROR_A:	;ecx=string
;=====================================================
	SHOWTEMPMESSAGE ecx
	mov eax,[dibfileheader.rv_rt_error_count]
	inc eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [TempMessageParam2],eax
	invoke GetLastError
	mov [TempMessageParam1],eax
jmp RV_FrameCaptureError_A

;=====================================================
DO_NEW_SAVE_METHOD_DXBLT:
;=====================================================

	cmp [DXBLT_FIRST_RUN],TRUE
	    jz INIT_DXBLT_TEMP_SURFACE
	INIT_DXBLT_TEMP_SURFACE_RET:

;get back buffer surface
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	mov esi,[ecx+4Ch]		;esi = DDSurface object (source)

	mov edi,[dx_temp_mem_surface]
	mov eax,[edi]

	push dx_temp_mem_DDBLTFX
	push DDBLT_WAIT
	push dx_temp_mem_RECT
	push esi
	push 0
	push edi
	call DWORD [eax+DirectDrawSurface.Blt]
	       test eax,eax
	       mov ecx,rv_error_27
		    jnz DO_REC_RT_ERROR_A_DX

;write frame to file
	       push 0
	       mov edx,esp
	invoke WriteFile,[dibtempfile_handle],[newsavetempbuffer],[vrdef_bufsize],edx,0
	       pop edx
	       test eax,eax
	       mov ecx,rv_error_25
		   jz DO_REC_RT_ERROR_A_DX
	       cmp edx,[vrdef_bufsize]
		   jnz DO_REC_RT_ERROR_A_DX

	inc [dibfileheader.DiffFrameCount]
	inc [dibfileheader.TrueFrameCount]

	RV_FrameCaptureError_A_DX:

;get device context to display video time using standard functions
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	call DisplayVideoTime

	mov eax,[BaseDDSurfaceADDR]
	push edi			 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]
ret

;=====================================================
INIT_DXBLT_TEMP_SURFACE:	 ;if first frame, set up temp surface
;=====================================================
;ERROR: if software mode is set, CreateSurface may return with INVALID_PARAMS (E_INVALIDARGS)

	    xor eax,eax
	    mov edi,dx_temp_memSD+4
	    mov ecx,(sizeof.DDSURFACEDESC2-4)/4
	    rep stosd

	    xor eax,eax
	    mov edi,newsavemethodSD.ddpfPixelFormat+4
	    mov ecx,(sizeof.DDPIXELFORMAT-4)/4
	    rep stosd

;get back buffer pixel format
	    mov [newsavemethodSD.ddpfPixelFormat.dwSize],sizeof.DDPIXELFORMAT
	    mov [newsavemethodSD.ddpfPixelFormat.dwFlags],DDPF_RGB

	    mov eax,[BaseDDSurfaceADDR]
	    mov ecx,[eax]
	    mov esi,[ecx+4Ch]		    ;esi = DDSurface object (source)

	    push newsavemethodSD.ddpfPixelFormat
	    mov eax,[esi]
	    push esi
	    call [eax+DirectDrawSurface.GetPixelFormat]
	    test eax,eax
	    mov ecx,rv_error_30
		 jnz DO_REC_RT_ERROR_A_DX_2

		mov eax,[newsavemethodSD.ddpfPixelFormat.dwRBitMask]
	    mov [dx_temp_memSD.ddpfPixelFormat.dwRBitMask],eax
		mov eax,[newsavemethodSD.ddpfPixelFormat.dwGBitMask]
	    mov [dx_temp_memSD.ddpfPixelFormat.dwGBitMask],eax
		mov eax,[newsavemethodSD.ddpfPixelFormat.dwBBitMask]
	    mov [dx_temp_memSD.ddpfPixelFormat.dwBBitMask],eax

	    mov [dx_temp_memSD.ddpfPixelFormat.dwRGBBitCount],16
	    mov [dx_temp_memSD.ddpfPixelFormat.dwSize],sizeof.DDPIXELFORMAT
	    mov [dx_temp_memSD.ddpfPixelFormat.dwFlags],DDPF_RGB

	    mov [dx_temp_memSD.dwSize],sizeof.DDSURFACEDESC2
	    mov [dx_temp_memSD.dwFlags],DDSD_WIDTH+DDSD_HEIGHT+DDSD_LPSURFACE+\
					DDSD_PITCH+DDSD_PIXELFORMAT+DDSD_CAPS
		mov eax,[newsavetempbuffer]
	    mov [dx_temp_memSD.lpSurface],eax
		mov eax,[dibfileheader.BitmapData.biWidth]
	    mov [dx_temp_memSD.dwWidth],eax
	    mov [dx_temp_mem_RECT.right],eax
		add eax,eax
	    mov [dx_temp_memSD.lPitch],eax
		mov eax,[dibfileheader.BitmapData.biHeight]
	    mov [dx_temp_memSD.dwHeight],eax
	    mov [dx_temp_mem_RECT.bottom],eax
	    mov [dx_temp_memSD.ddsCaps.dwCaps],DDSCAPS_OFFSCREENPLAIN+DDSCAPS_SYSTEMMEMORY

	    call GetDDrawObject
	    test eax,eax
	    mov ecx,rv_error_28
		 jz DO_REC_RT_ERROR_A_DX

	    mov edx,[eax]
	    push 0
	    push dx_temp_mem_surface
	    push dx_temp_memSD
	    push eax
	    call [edx+DirectDraw.CreateSurface]
	    test eax,eax
	    mov ecx,rv_error_29
		 jnz DO_REC_RT_ERROR_A_DX_2

	mov [DXBLT_FIRST_RUN],FALSE

jmp INIT_DXBLT_TEMP_SURFACE_RET

;=====================================================
DO_REC_RT_ERROR_A_DX:	   ;ecx=string
;=====================================================
	SHOWTEMPMESSAGE ecx
	mov eax,[dibfileheader.rv_rt_error_count]
	inc eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [TempMessageParam2],eax
	invoke GetLastError
	mov [TempMessageParam1],eax
jmp RV_FrameCaptureError_A_DX

DO_REC_RT_ERROR_A_DX_2:
	mov [TempMessageParam1],eax
	SHOWTEMPMESSAGE ecx
	mov eax,[dibfileheader.rv_rt_error_count]
	inc eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [TempMessageParam2],eax
jmp RV_FrameCaptureError_A_DX

;=====================================================
DisplayVideoTime:
;=====================================================
push ebp
mov ebp,esp
sub esp,200

	fild [dibfileheader.TrueFrameCount]
	fmul [vrdef_frametimediv1000]  ;framecount*(time/frame) = elapsed time (in seconds)
	fistp DWORD [ebp-4]

	lea ebx,[ebp-200]
invoke wsprintf,ebx,VideoElapsedTime_STR,[ebp-4],[dibfileheader.TrueFrameCount],\
		[dibfileheader.MaxFrameCount],[dibfileheader.FrameRepCount]
	add esp,6*4
invoke TextOut,edi,0,VIDEO_TIME_MSG,ebx,eax

mov esp,ebp
pop ebp
ret

;=====================================================
InitAudioCapture_REC:
;=====================================================
	cmp [mci_audio_capt_enabled],0
	    jz NoInitAudioCapture_REC
	invoke mciSendString,mcistr_open1,0,0,0

	push ebp
	mov ebp,esp
	sub esp,512
	    push [mci_bytespersec]
	    sub esp,4
	    push [mci_samplespersec]
	    mov eax,[mci_channelcount]
	    mov ecx,[mci_bitspersample]
	    push eax
	    push ecx
	    mul ecx
	    shr eax,3
	    mov [esp+12],eax
	    lea edx,[ebp-512]
	    invoke wsprintf,edx,mcistr_set1_str
	    add esp,7*4

	    lea edx,[ebp-512]
	    invoke mciSendString,edx,0,0,0
	mov esp,ebp
	pop ebp

	invoke mciSendString,mcistr_cue1,0,0,0
	invoke mciSendString,mcistr_record1,0,0,0
	or [mci_capt_in_progress],1

	test [NewSaveMethod],SAVE_METHOD_NONE
	     jz NoVideoRecordNewRT_B
	     mov [dibfileheader.TrueFrameCount],1	 ;(for record proc first run condition)
	NoVideoRecordNewRT_B:
	NoInitAudioCapture_REC:
ret

;=====================================================
EndAudioCapture_REC:
;=====================================================
	cmp [mci_capt_in_progress],0
	    jz NoEndAudioCapture_REC
	invoke mciSendString,mcistr_stop1,0,0,0
	invoke mciSendString,mcistr_save1,0,0,0
	invoke mciSendString,mcistr_close1,0,0,0
	and [mci_capt_in_progress],0
	NoEndAudioCapture_REC:
ret


;=====================================================
ReleaseAllAVIBuffers:		;use in-game only
;=====================================================
	call EndAudioCapture_REC
;does not release AVIFIL32 dll or AVISaveOptions data
	mov ecx,[dx_temp_mem_surface]
	test ecx,ecx
	     jz No_Release_dx_temp_mem_surface
	     mov eax,[ecx]
	     push ecx
	     call [eax+DirectDrawSurface.Release]
	     mov [dx_temp_mem_surface],0
	No_Release_dx_temp_mem_surface:

	LOCALRELEASE [framerepeatcount_BUF]
	RCALL CloseHandle,[dibtempfile_handle]
	VIRTUALRELEASE [newsavetempbuffer],[vrdef_bufsize]
ret

;=====================================================
;REC cheat (un-)initialization (included in _MAIN_CHEATS.inc)
;=====================================================
Do_Video_Record_Toggle_Main:

	cmp [VideoEnabledBool],1
	    jz ENDVIDEOCAPTURE
	test esi,esi
	    jz NOVIDEONAMESPECIFIED

;set initial variables

	       push esi
	       push edi
	       mov edi,recvideonamebuf
	       call TransferString
	       mov DWORD [edi],'.rec'
	       test [NewSaveMethod],SAVE_METHOD_NONE
		    jz NoWavExtensionSet_A
		    mov DWORD [edi],'.wav'
	       NoWavExtensionSet_A:
	       mov BYTE [edi+4],0
	       pop edi
	       pop esi

	       push esi
	       push edi
	       mov edi,mcistr_savename_buf
	       call TransferString
	       mov DWORD [edi],'.wav'
	       mov BYTE [edi+4],0
	       pop edi
	       pop esi

;make sure SaveMethod value is valid
	mov eax,[NewSaveMethod]
	mov edx,ValidSaveMethodsTable
	mov ecx,(ValidSaveMethodsTable_END-ValidSaveMethodsTable)/4
	CheckSaveMethodNumber:
	cmp eax,[edx]
	    jz SaveMethodNumberValid
	add edx,4
	loop CheckSaveMethodNumber
	    mov edi,rv_error_A
	    jmp CAPTURESTARTERROR
	SaveMethodNumberValid:

;no video capture (possibly audio only)?
	test [NewSaveMethod],SAVE_METHOD_NONE
	     jnz SAVE_METHOD_NONE_A1

	xor eax,eax
	mov [VideoEnabledBool],al	 ;ensure recording disabled before starting (in case)
	mov [dibfileheader.TrueFrameCount],eax
	mov [dibfileheader.DiffFrameCount],eax
	mov [dibfileheader.FrameRepCount],eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [newsavemethodSD.ddpfPixelFormat.dwGBitMask],eax

	mov [dibfileheader.BitmapData.biCompression],BI_RGB
	mov [dibfileheader.BitmapData.biPlanes],1
	mov [dibfileheader.BitmapData.biBitCount],16
	;mov [dibfileheader.BitmapData.biClrUsed],0

	mov eax,[NewSaveMethod]
	cmp eax,SAVE_METHOD_OLD_24
	    jnz No24BitDepthSet
	    mov [dibfileheader.BitmapData.biBitCount],24
	No24BitDepthSet:

	fild [dibfileheader.Framerate]
	fdivr [float_1000]
	fst [vrdef_frametime]
	fist [vrdef_frametime_INT]
	fmul [float_0_001]
	fstp [vrdef_frametimediv1000]

	mov eax,[dibfileheader.BitmapData.biWidth]
	mov ecx,[dibfileheader.BitmapData.biHeight]
	mul ecx
	xor ecx,ecx
	mov cx,[dibfileheader.BitmapData.biBitCount]
	shr ecx,3
	mul ecx
	mov [vrdef_bufsize],eax

	cmp [NewSaveMethod],SAVE_METHOD_OLD_16
	    jz NoNewTempFrameBufferInit
	cmp [NewSaveMethod],SAVE_METHOD_OLD_24
	    jz NoNewTempFrameBufferInit
;temp frame buffer for new save method
	invoke VirtualAlloc,0,[vrdef_bufsize],MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE
	       test eax,eax
	       mov edi,rv_error_9
		   jz CAPTURESTARTERROR
	       mov [newsavetempbuffer],eax
	NoNewTempFrameBufferInit:

;create frame repeat count buffer (256 max repeats for every different frame)
	invoke LocalAlloc,LPTR,[dibfileheader.MaxFrameCount]
	       test eax,eax
	       mov edi,rv_error_6
		    jz CAPTURESTARTERROR
	       mov [framerepeatcount_BUF],eax

;create main DIB temp file

	cmp [UseRECWriteThrough],FALSE
	mov edx,FILE_FLAG_SEQUENTIAL_SCAN
	    jz NoUseRECWriteThrough
	    or edx,FILE_FLAG_WRITE_THROUGH
	NoUseRECWriteThrough:

	invoke CreateFile,recvideonamebuf,GENERIC_READ+GENERIC_WRITE,0,0,CREATE_ALWAYS,edx,0
	       cmp eax,-1
	       mov edi,rv_error_7
		    jz CAPTURESTARTERROR
	       mov [dibtempfile_handle],eax

;write initial (mainly empty or invalid) header
	invoke SetFilePointer,[dibtempfile_handle],0,0,FILE_BEGIN
	       push 0
	       mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],dibfileheader,[dibfileheader.HeaderSize],ecx,0
	       pop edx
	       test eax,eax
	       mov edi,rv_error_8
		    jz CAPTURESTARTERROR
	       cmp edx,[dibfileheader.HeaderSize]
		   jnz CAPTURESTARTERROR

	mov [DXBLT_FIRST_RUN],TRUE
	SAVE_METHOD_NONE_A1:
	or [VideoEnabledBool],1 				;start recording

jmp EXITCHEATCODE

CAPTURESTARTERROR:
	call ReleaseAllAVIBuffers
	SHOWTEMPMESSAGE edi
jmp EXITCHEATCODE

NOVIDEONAMESPECIFIED:
	SHOWTEMPMESSAGE rv_no_spec_file
jmp EXITCHEATCODE

ENDVIDEOCAPTURE:
;MUST SAVE FRAME REPEAT COUNT TO END OF CUSTOM DIB FILE
;AND WRITE FILE HEADER INFO AT START (SPACE PRE-ALLOCATED)

	and [VideoEnabledBool],0
	call EndAudioCapture_REC
	mov eax,[NewSaveMethod]
	test eax,SAVE_METHOD_NONE
	mov edi,rv_encode_success
	     jnz AVITerminateError_A

;fill in header and bitmap info

	mov [dibfileheader.SaveFlags],0
	test eax,SAVE_METHOD_OLD_BOOL
	     jnz Not16DepthAltFormat
	    cmp [newsavemethodSD.ddpfPixelFormat.dwGBitMask],07E0h
		jnz Not16DepthAltFormat
	    or [dibfileheader.SaveFlags],PIXEL_FORMAT_16_5_6_5
	Not16DepthAltFormat:

	cmp eax,SAVE_METHOD_NEW_DX
	    jnz NoImageInvert_A
	    or [dibfileheader.SaveFlags],INVERT_UP_DOWN_IMAGES
	NoImageInvert_A:

	mov eax,[vrdef_bufsize]
	;mov [dibfileheader.BitmapData.biSizeImage],eax
	mov ecx,[dibfileheader.DiffFrameCount]
	mul ecx 				;get total size of DIB data
	add eax,[dibfileheader.HeaderSize]	;eax points to EOF
	mov [dibfileheader.FrameRepeatTableFileOffset],eax
	mov [dibfileheader.FrameRepeatTableFileOffsetHigh],edx

;append frame repeat data to end of file
	       push edx
	       mov ecx,esp
;ensure file pointer is put after the DIB data (at EOF)
	invoke SetFilePointer,[dibtempfile_handle],eax,ecx,FILE_BEGIN
	       add esp,4

;write the frame repeat buffer data at end of file
	       push 0
	       mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],[framerepeatcount_BUF],[dibfileheader.DiffFrameCount],ecx,0
	       mov edi,rv_error_4
	       test eax,eax
	       pop ecx
		   jz AVITerminateError_A
	       cmp ecx,[dibfileheader.DiffFrameCount]
		   jnz AVITerminateError_A

;write header information to file

	invoke SetFilePointer,[dibtempfile_handle],0,0,FILE_BEGIN

	       push 0
	       mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],dibfileheader,[dibfileheader.HeaderSize],ecx,0
	       mov edi,rv_error_5
	       test eax,eax
	       pop ecx
		   jz AVITerminateError_A
	       cmp ecx,[dibfileheader.HeaderSize]
		   jnz AVITerminateError_A

	       mov edi,rv_encode_success

AVITerminateError_A:
	call ReleaseAllAVIBuffers
	SHOWTEMPMESSAGE edi
jmp EXITCHEATCODE




